# frozen_string_literal: true

module ::YeSQL
  module Bindings
    module Utils
      include ::YeSQL::Utils::Read

      def statement_binds(extractor)
        statement(readable: true)
          .scan(::YeSQL::BIND_REGEX)
          .map(&:first)
          .map { extractor[_1.to_sym][:bind].values_at(:vals, :vars) }
      end
    end
  end
end
